import { TypeOrmCrudService } from "@nestjsx/crud-typeorm";
import { Interaction } from "./interaction.entity";
import { DeepPartial, DeleteResult, EntityManager, FindOperator, InsertResult, Repository, UpdateResult } from "typeorm";
import { Network } from "../network/network.entity";
import { Token } from "../token/token.entity";
import { Farm } from "../farm/farm.entity";
import { Lending } from "../lending/lending.entity";
import { NFToken } from "../nf-token/nf-token.entity";
export declare class InteractionService extends TypeOrmCrudService<Interaction> {
    readonly repo: Repository<Interaction>;
    private readonly entity;
    private readonly relations;
    private readonly recursiveRelations;
    constructor(repo: Repository<Interaction>);
    findOneBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<Interaction>;
    findAllBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<Interaction[]>;
    createOneBy(params: DeepPartial<Interaction>, manager?: EntityManager): Promise<Interaction>;
    createAllBy(params: DeepPartial<Interaction>[], manager?: EntityManager): Promise<Interaction[]>;
    createAllIfNotExistBy(params: DeepPartial<Interaction>[], manager?: EntityManager): Promise<InsertResult>;
    updateOneBy(where: any, set: {
        [K in keyof Interaction]?: any;
    }, manager?: EntityManager): Promise<UpdateResult>;
    deleteOneBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<DeleteResult>;
    getTokenInteractions(address: string, network?: Network): Promise<Token[]>;
    getFarmInteractions(address: string, network: Network): Promise<Farm[]>;
    getLendingInteractions(address: string, network: Network): Promise<Lending[]>;
    getERC721NFTokenInteractions(address: string, network: Network): Promise<NFToken[]>;
    getERC1155NFTokenInteractions(address: string, network: Network): Promise<NFToken[]>;
}
